
let basic () =
  let a = array_create 3 111 in
  array_set a 0 222;
  array_set a 1 333;
  array_length a = 3
  && array_get a 0 = 222
  && array_get a 1 = 333
  && array_get a 2 = 111

let imm () =
  let a = [|1;2;3|] in
  array_length a = 3
  && array_get a 0 = 1
  && array_get a 1 = 2
  && array_get a 2 = 3

let double () =
  let a = [| [| 0 |]; [| 1; 2 |] |] in
  a.(0).(0) = 0
  && array_length a.(0) = 1
  && a.(1).(0) = 1
  && a.(1).(1) = 2
  && array_length a.(1) = 2

let init () =
  let a = array_init 2 (fun i -> array_init 2 (fun j -> (i,j))) in
  a.(0).(0) = (0,0)
  && a.(0).(1) = (0,1)
  && a.(1).(0) = (1,0)
  && a.(1).(1) = (1,1)
  && array_length a = 2
  && array_length a.(0) = 2
  && array_length a.(1) = 2

let max_size () =
  let a = array_init 256 (fun i -> i) in
  a.(0) = 0
  && a.(255) = 255

let small_alloc () =
  let a = array_init 2 (fun i -> i) in
  a.(0) = 0
  && a.(1) = 1

let main =
  basic ()
  && imm ()
  && double ()
  && init ()
  && max_size ()
  && small_alloc ()
